#ifndef GLUTWM_H
#define GLUTWM_H

#if defined(__APPLE__) && defined(__MACH__)
#include <OpenGL/gl.h>
#include <OpenGL/glext.h>
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

class Window;

void GlutWMOpen(int *argc, char *argv[]);
void GlutWMClose(void) ;

int GlutWMDestroyWindow(int id);
int GlutWMCreateWindow(const char *name, Window *wnd);
int GlutWMReplaceWindow(int id, const char *name, Window *wnd);
void GlutWMSetWindow(int id);

void GlutWMShowWindow(int id = -1);
void GlutWMHideWindow(int id = -1);

void GlutWMPostRedisplay(int id = -1);
void GlutWMSwapBuffers(int id = -1);
void GlutWMFullScreen(int id = -1);

void GlutWMIdleFunc(void (*idle)(void));
void GlutWMStartIdle(int id = -1);
void GlutWMStopIdle(int id = -1);

void GlutWMMetaIdleFunc(void (*set)(void (*f)(void)));
void GlutWMMetaDisplayFunc(void (*set)(void (*f)(void)));
void GlutWMMetaMouseFunc(void (*set)(void (*f)(int, int, int ,int)));
void GlutWMMetaMotionFunc(void (*set)(void (*f)(int, int)));
void GlutWMMetaReshapeFunc(void (*set)(void (*f)(int, int)));
void GlutWMMetaKeyboardFunc(void (*set)(void (*f)(unsigned char, int, int)));

void GlutWMInitWindowSize(int w, int h);
void GlutWMInitDisplayMode(int m);
void GlutWMReshapeWindow(int id, int w, int h);
void GlutWMPositionWindow(int id, int x, int y);
void GlutWMMainLoop(void);

void GlutWMDrawPixels(GLsizei width, GLsizei height, GLenum format,
        const unsigned char *data);
void GlutWMDrawPixels(GLsizei width, GLsizei height, GLenum format,
        const unsigned short *data);
void GlutWMDrawPixels(GLsizei width, GLsizei height, GLenum format,
        const unsigned long *data);
void GlutWMDrawPixels(GLsizei width, GLsizei height, GLenum format,
        const float *data);

void GlutWMReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, 
        GLenum format, unsigned char *data);
void GlutWMReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, 
        GLenum format, unsigned short *data);
void GlutWMReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, 
        GLenum format, unsigned long *data);
void GlutWMReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, 
        GLenum format, float *data);

#endif // GLUTWM_H
