#ifndef PNGIMAGE_H
#define PNGIMAGE_H

#include <cstdio>
#include <png.h>
#include "image.h"

class PngImage: public Image {
    public:
        PngImage(void);
        virtual ~PngImage();
        int Load(FILE *fp);
        int Load(const char *name);
        int Load(const BufferUchar &other); 
        int Load(const Uchar *data, size_t size); 
        int Store(const char *name);
        int Store(FILE *fp);
        int Store(BufferUchar &other);
        int GetWidth(void) const;
        int GetHeight(void) const;
        int Store(BufferUshort &other);
        int Load(const BufferUshort &other); 
    private:
        int SetupRead(void);
        int AllocateReadStructures(void);
        int SetupWrite(void);
        int AllocateWriteStructures(void);
        int SetupRows(void);
        png_structp read_struct, write_struct;
        png_infop info_struct, end_info_struct;
        BufferUshort data;
        png_bytepp rows;
        int nrows;
        int bit_depth;
        int swap;
};

#endif // PNGIMAGE_H
