#ifndef _WINDOW_H_
#define _WINDOW_H_

#include <cstdlib>

#include "glutwm.h"

class Window {
    public:
        Window(void) { id = 0; }
        virtual ~Window(void) { ; }
        virtual void Init(int id) { this->id = id; }
        virtual void Destroy(void) { id = 0; }
        virtual void Display(void) { ; }
        virtual void Idle(void) { GlutWMStopIdle(id); }
        virtual void Reshape(int w, int h, int x0 = 0, int y0 = 0) 
        { this->x0 = x0; this->y0 = y0; this->w = w; this->h = h; } 
        virtual void Motion(int x, int y) { (void) x; (void) y; }
        virtual void Button(int button, int state, int x, int y) 
        { (void) button; (void) state; (void) x; (void) y; }
        virtual void Keyboard(unsigned char c, int x, int y) 
        { (void) x; (void) y; if (c == 'q' || c == 'Q') exit(0); }
        virtual void Adjust(int *x, int *y) 
        { *x = *x - x0; *y = h - (*y - y0) - 1; }
        virtual int GetWidth(void) { return w; }
        virtual int GetHeight(void) { return h; }
        virtual int GetId(void) { return id; }
        virtual int GetX0(void) { return x0; }
        virtual int GetY0(void) { return y0; }
		virtual void MakeCurrent(void) { GlutWMSetWindow(id); }
		virtual void StartIdle(void) { GlutWMStartIdle(id); }
		virtual void StopIdle(void) { GlutWMStopIdle(id); }
		virtual void PostRedisplay(void) { GlutWMPostRedisplay(id); }
		virtual void Hide(void) { GlutWMHideWindow(id); }
		virtual void Show(void) { GlutWMShowWindow(id); }
    private:
        int id, x0, y0, w, h;
};

#endif // _WINDOW_H_
